#ifndef MYHEADER_H
#define MYHEADER_H

#include <ultra64.h>

typedef enum {
	LAYERATTRIBUTE_NONE = 0x0,
	LAYERATTRIBUTE_PREVENT_SEAMS = 0x1,
} LayerAttributes;


#define RECTANGLE_INIT(p0x, p0y, p1x, p1y) \
{ p0x, p0y, p1x, p1y }

typedef struct {
	u16    p0x, p0y;
	u16    p1x, p1y;
} Rectangle;


#define TEXTURE_INIT(w, h, pix, pal, f)	\
{ .width = w, .height = h, .pixels = pix, .palette = pal, .fmt = f }

typedef enum {
	TEXTURE_FMT_CI4,
	TEXTURE_FMT_RGBA16,
	TEXTURE_FMT_RGBA32,
        TEXTURE_FMT_UNKNOWN
} TextureFormat;

typedef struct {
	u16		width;
	u16		height;
	void*		pixels;
	void*		palette;
	TextureFormat	fmt;
} Texture;


typedef struct {
	float	x;
	float	y;
	float	z;
} Vector3f;


typedef struct {
	Vector3f	color;
	Texture*	tex;
} Material;


typedef struct {
	Material* mat;
	Gfx* gfx;
        Rectangle	tile;
	LayerAttributes	attr;
} Layer;

#endif	/* MYHEADER_H */
